@echo off
SET AUBIO=%cd%\aubio\
call :processwav
pause
goto :eof

:convertpcm
echo Convert to pcm "%~1"
ffmpeg -i "%~1" -hide_banner -loglevel panic -acodec pcm_s16le "%~n1_pcm.wav"
ren "%~1" "%~1.original"
ren "%~n1_pcm.wav" "%~1"
%AUBIO%\aubiotrack "%~1" > "%~n1.beats"
exit /b 0

:processwav
for %%f in (*.wav) do (
	IF NOT EXIST "%%~nf.beats" (
		%AUBIO%\aubiotrack "%%f" > "%%~nf.beats" || call :convertpcm "%%f"
		echo 	"%%~nf.beats"
	)
	IF NOT EXIST "%%~nf.onset" (
		%AUBIO%\aubioonset -i "%%f" -O complex -M 0.1 -t 0.3 -f > "%%~nf.onset" && echo 	"%%~nf.onset"
	)
)

for /D %%d in (*) do (
    cd %%d
    call :processwav
    cd ..
)
exit /b